/* $Id: pluck.java,v 1.10 2012/02/04 08:01:25 mit Exp $ */
/* pluck.java v0.0 */
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;

public class pluck extends Applet 
    implements Runnable, ActionListener, AdjustmentListener
{
    private Panel PS;
    private Button btGo;
    private Button btStop;
    private Button btDisp;
    private Scrollbar scrPP;
    private Label lbPP;
    private Thread th;

    static int LEN = 64;
    static int PAR = 40;
    static int HZ = 1;
    static int FLM = 64;
    static double DT = 2.0*Math.PI/FLM;

    boolean Runsw;
    int W;
    int H;
    int H2;
    int DOT = 4;
    int SFT = DOT/2;
    int LOOP;
    int DISP;
    double PP = 8.0/LEN;
    double DD;
    double DH;

    Graphics gi;
    Image ig;
    DecimalFormat df1;

    public void init() {
        setFont(new Font("SansSerif", Font.PLAIN, 12));
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());
	df1 = new DecimalFormat("#0.0#");

	PS = new Panel();
        PS.setLayout(new GridLayout(2,3,0,0));

        btGo = new Button("GO");
        PS.add(btGo);
        btGo.addActionListener(this);

        btStop = new Button("Stop");
        PS.add(btStop);
        btStop.addActionListener(this);

	PS.add(new Label(""));

	scrPP = new Scrollbar(Scrollbar.HORIZONTAL,LEN/8,1,1,LEN);
        PS.add(scrPP);
        scrPP.addAdjustmentListener(this);

	lbPP = new Label(": Plucking Point 1/___");
	PS.add(lbPP);

        btDisp = new Button("Disp.");
        PS.add(btDisp);
        btDisp.addActionListener(this);

	add(PS, "South");
    }
    public void start() {
        W = getCanvasD().width;
        H = getCanvasD().height;
	H2 = H/2;
	DD = W/(double)(LEN+1); // +1
	DH = H/5.0;

	ig = createImage(W, H);
	gi = ig.getGraphics();

	set_label();

	if (th == null) {
            th = new Thread(this);
            th.start();
        }
    }
    public Dimension getCanvasD() {
        Dimension ds = PS.getSize();
        Dimension da = getSize();
        int cw = da.width;
        int ch = da.height-ds.height;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void run() {
	while(!Runsw) {
            try {
		LOOP++;
		if (LOOP > FLM)
		    LOOP = 0;

		repaint();
                th.sleep(100);
            } 
            catch (InterruptedException e) {
                System.out.println(e);
            }
        }
    }
    public void stop() {
        if (th != null) {
            th = null;

	    LOOP = 0;
	}
    }
    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == btStop)
	    Runsw = true;
        else if (e.getSource() == btGo) {
            Runsw = false;
            th = null;
            start();
        }
	else if (e.getSource() == btDisp)
	    set_disp();
    }
    public void set_disp() {
	DISP++;
	if (DISP > 2)
	    DISP = 0;
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
        if (e.getSource() == scrPP) {
	    PP = scrPP.getValue()/(double)LEN;
	    set_label();

	    repaint();
	}
    }
    public void set_label() {
	lbPP.setText(": Plucking Point 1/"+dform(1/PP));
    }
    public String dform(double n) {
        return df1.format((float)n);
    }
    //
    public void update(Graphics g) {
        paint(g);
    }
    public void paint(Graphics g) {
        paintI();
        g.drawImage(ig, 0, 0, this);
    }
    public void paintI() {
        gi.setColor(Color.black);
        gi.fillRect(0, 0, W, H);

	disp_line(gi);

	int dx;
	double[] val = new double[3];
	for (int i = 0; i <= LEN; i++) { // LENޤ
	    dx = (int)(DD*i+SFT);

	    val = plucking(i);

	    if (DISP > 0) {
		gi.setColor(Color.gray);
		gi.fillOval(dx, (int)(H2-DH*val[1]), DOT, DOT);
		gi.fillOval(dx, (int)(H2-DH*val[2]), DOT, DOT);
	    }

	    if (DISP < 2) {
		gi.setColor(Color.green);
		gi.fillOval(dx, (int)(H2-DH*val[0]), DOT, DOT);
	    }
	}
    }
    public double[] plucking(int x) {
	double mp, ms, te;
	double[] len = new double[3];

	for (int i = 1; i < PAR; i++) {  // 1~
	    mp = i*Math.PI;
	    te = i*DT*LOOP*HZ;
	    ms = 1.0/(i*i)*Math.sin(mp*x/LEN);
	    len[1] += ms*Math.sin(mp*PP-te);
	    len[2] += ms*Math.sin(mp*PP+te);
	}
	len[0] = len[1]+len[2];

	return len;
    }
    public void disp_line(Graphics g) {
	g.setColor(Color.gray);
	g.drawLine(0, H2+SFT, W, H2+SFT);
    }
}